module Allow
  VERSION = "0.0.1"

  module Permissions
    def permitted?(actor, verb, *objects)
      return false unless respond_to?(verb)
      !!send(verb, actor, *objects)
    end
  end

  module Actor
    def can?(verb, *objects, &block)
      Allow.ed?(self, verb, *objects, &block)
    end
  end

  class << self
    attr_accessor :permissions
  end

  def self.reset!
    @permissions = Class.new { include Permissions }.new
  end

  def self.ed?(actor, verb, *objects, &block)
    permitted = permissions.permitted?(actor, verb, *objects)
    block.call if permitted && block
    permitted
  end
end

Allow.reset!
